<?php

namespace l27Bfug;

class Base {
    public static $plugin_url;
    public static $request_url;
    public static $settings;
    public static $current_route;
    public static $current_view;

    private static $no_auth_routes = array('login');

    const listings_per_page = 30;
    const default_route = 'forms_list';

    private static $construct_executed = false;

    public function __construct() {
        self::init();
    }

    public static function init() {
        $plugin_url = $_SERVER['SCRIPT_NAME'];
        if (isset($_SERVER['QUERY_STRING'])) $plugin_url .= '?page=' . L27_BFUG_SLUG;
        self::$plugin_url = $plugin_url;

        self::$settings = l27_bfug_get_settings();
        self::$construct_executed = true;
    }

    public static function hook_before() {
        if (!self::$construct_executed) {
            self::init();
        }

        if (!self::$current_route) {
            self::$current_route = self::default_route;
        }

        if (!isset(self::$settings['auth']) || !self::$settings['auth']) {
            if (!in_array(self::$current_route, self::$no_auth_routes)) {
                l27_bfug_redirect_to_route('login');
            }
        }
        else {
            if (in_array(self::$current_route, self::$no_auth_routes)) {
                l27_bfug_redirect_to_route();
            }
        }
    }
}